diff -ruNp linux-2.6.16.5/fs/compat.c linux-2.6.16.5-cher1/fs/compat.c
--- linux-2.6.16.5/fs/compat.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/fs/compat.c	2006-04-13 11:55:22.000000000 +0400
@@ -63,6 +63,9 @@ asmlinkage long compat_sys_utime(char __
 {
 	struct timeval tv[2];
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (t) {
 		if (get_user(tv[0].tv_sec, &t->actime) ||
 		    get_user(tv[1].tv_sec, &t->modtime))
@@ -77,6 +80,9 @@ asmlinkage long compat_sys_futimesat(uns
 {
 	struct timeval tv[2];
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (t) {
 		if (get_user(tv[0].tv_sec, &t[0].tv_sec) ||
 		    get_user(tv[0].tv_usec, &t[0].tv_usec) ||
@@ -96,8 +102,12 @@ asmlinkage long compat_sys_newstat(char 
 		struct compat_stat __user *statbuf)
 {
 	struct kstat stat;
-	int error = vfs_stat_fd(AT_FDCWD, filename, &stat);
+        int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
+	error = vfs_stat_fd(AT_FDCWD, filename, &stat);
 	if (!error)
 		error = cp_compat_stat(&stat, statbuf);
 	return error;
@@ -107,9 +117,13 @@ asmlinkage long compat_sys_newlstat(char
 		struct compat_stat __user *statbuf)
 {
 	struct kstat stat;
-	int error = vfs_lstat_fd(AT_FDCWD, filename, &stat);
+        int error;
 
-	if (!error)
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
+        error = vfs_lstat_fd(AT_FDCWD, filename, &stat);
+        if (!error)
 		error = cp_compat_stat(&stat, statbuf);
 	return error;
 }
@@ -120,6 +134,9 @@ asmlinkage long compat_sys_newfstatat(un
 	struct kstat stat;
 	int error = -EINVAL;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if ((flag & ~AT_SYMLINK_NOFOLLOW) != 0)
 		goto out;
 
@@ -139,8 +156,12 @@ asmlinkage long compat_sys_newfstat(unsi
 		struct compat_stat __user * statbuf)
 {
 	struct kstat stat;
-	int error = vfs_fstat(fd, &stat);
+        int error;
+
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
 
+	error = vfs_fstat(fd, &stat);
 	if (!error)
 		error = cp_compat_stat(&stat, statbuf);
 	return error;
@@ -192,6 +213,9 @@ asmlinkage long compat_sys_statfs(const 
 	struct nameidata nd;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = user_path_walk(path, &nd);
 	if (!error) {
 		struct kstatfs tmp;
@@ -209,6 +233,9 @@ asmlinkage long compat_sys_fstatfs(unsig
 	struct kstatfs tmp;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -257,6 +284,9 @@ asmlinkage long compat_sys_statfs64(cons
 	struct nameidata nd;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (sz != sizeof(*buf))
 		return -EINVAL;
 
@@ -277,6 +307,9 @@ asmlinkage long compat_sys_fstatfs64(uns
 	struct kstatfs tmp;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (sz != sizeof(*buf))
 		return -EINVAL;
 
@@ -375,6 +408,9 @@ asmlinkage long compat_sys_ioctl(unsigne
 	struct ioctl_trans *t;
 	int fput_needed;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	filp = fget_light(fd, &fput_needed);
 	if (!filp)
 		goto out;
@@ -510,6 +546,9 @@ asmlinkage long compat_sys_fcntl64(unsig
 	struct flock f;
 	long ret;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	switch (cmd) {
 	case F_GETLK:
 	case F_SETLK:
@@ -587,6 +626,10 @@ compat_sys_io_setup(unsigned nr_reqs, u3
 	aio_context_t ctx64;
 
 	mm_segment_t oldfs = get_fs();
+
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (unlikely(get_user(ctx64, ctx32p)))
 		return -EFAULT;
 
@@ -611,6 +654,9 @@ compat_sys_io_getevents(aio_context_t ct
 	struct timespec t;
 	struct timespec __user *ut = NULL;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	ret = -EFAULT;
 	if (unlikely(!access_ok(VERIFY_WRITE, events, 
 				nr * sizeof(struct io_event))))
@@ -651,6 +697,9 @@ compat_sys_io_submit(aio_context_t ctx_i
 	struct iocb __user * __user *iocb64; 
 	long ret;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (unlikely(nr < 0))
 		return -EINVAL;
 
@@ -838,6 +887,9 @@ asmlinkage long compat_sys_mount(char __
 	char *dir_page;
 	int retval;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	retval = copy_mount_options (type, &type_page);
 	if (retval < 0)
 		goto out;
@@ -934,6 +986,9 @@ asmlinkage long compat_sys_old_readdir(u
 	struct file *file;
 	struct compat_readdir_callback buf;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -1009,6 +1064,9 @@ asmlinkage long compat_sys_getdents(unsi
 	struct compat_getdents_callback buf;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = -EFAULT;
 	if (!access_ok(VERIFY_WRITE, dirent, count))
 		goto out;
@@ -1101,6 +1159,9 @@ asmlinkage long compat_sys_getdents64(un
 	struct compat_getdents_callback64 buf;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = -EFAULT;
 	if (!access_ok(VERIFY_WRITE, dirent, count))
 		goto out;
@@ -1328,6 +1389,9 @@ compat_sys_open(const char __user *filen
 asmlinkage long
 compat_sys_openat(unsigned int dfd, const char __user *filename, int flags, int mode)
 {
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	return do_sys_open(dfd, filename, flags, mode);
 }
 
@@ -2133,6 +2197,9 @@ asmlinkage long compat_sys_nfsservctl(in
 	mm_segment_t oldfs;
 	int err;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	karg = kmalloc(sizeof(*karg), GFP_USER);
 	kres = kmalloc(sizeof(*kres), GFP_USER);
 	if(!karg || !kres) {
@@ -2195,3 +2262,9 @@ long asmlinkage compat_sys_nfsservctl(in
 	return sys_ni_syscall();
 }
 #endif
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/fs/dcache.c linux-2.6.16.5-cher1/fs/dcache.c
--- linux-2.6.16.5/fs/dcache.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/fs/dcache.c	2006-04-13 11:55:22.000000000 +0400
@@ -1471,8 +1471,12 @@ asmlinkage long sys_getcwd(char __user *
 	int error;
 	struct vfsmount *pwdmnt, *rootmnt;
 	struct dentry *pwd, *root;
-	char *page = (char *) __get_free_page(GFP_USER);
+	char *page;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
+	page = (char *) __get_free_page(GFP_USER);
 	if (!page)
 		return -ENOMEM;
 
@@ -1767,3 +1771,9 @@ EXPORT_SYMBOL(have_submounts);
 EXPORT_SYMBOL(names_cachep);
 EXPORT_SYMBOL(shrink_dcache_parent);
 EXPORT_SYMBOL(shrink_dcache_sb);
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/fs/dcookies.c linux-2.6.16.5-cher1/fs/dcookies.c
--- linux-2.6.16.5/fs/dcookies.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/fs/dcookies.c	2006-04-13 11:55:22.000000000 +0400
@@ -151,6 +151,9 @@ asmlinkage long sys_lookup_dcookie(u64 c
 	size_t pathlen;
 	struct dcookie_struct * dcs;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	/* we could leak path information to users
 	 * without dir read permission without this
 	 */
@@ -327,3 +330,9 @@ void dcookie_unregister(struct dcookie_u
 EXPORT_SYMBOL_GPL(dcookie_register);
 EXPORT_SYMBOL_GPL(dcookie_unregister);
 EXPORT_SYMBOL_GPL(get_dcookie);
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/fs/eventpoll.c linux-2.6.16.5-cher1/fs/eventpoll.c
--- linux-2.6.16.5/fs/eventpoll.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/fs/eventpoll.c	2006-04-13 11:55:22.000000000 +0400
@@ -510,6 +510,9 @@ asmlinkage long sys_epoll_create(int siz
 	struct inode *inode;
 	struct file *file;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	DNPRINTK(3, (KERN_INFO "[%p] eventpoll: sys_epoll_create(%d)\n",
 		     current, size));
 
@@ -559,6 +562,9 @@ sys_epoll_ctl(int epfd, int op, int fd, 
 	struct epitem *epi;
 	struct epoll_event epds;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	DNPRINTK(3, (KERN_INFO "[%p] eventpoll: sys_epoll_ctl(%d, %d, %d, %p)\n",
 		     current, epfd, op, fd, event));
 
@@ -661,6 +667,9 @@ asmlinkage long sys_epoll_wait(int epfd,
 	struct file *file;
 	struct eventpoll *ep;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	DNPRINTK(3, (KERN_INFO "[%p] eventpoll: sys_epoll_wait(%d, %p, %d, %d)\n",
 		     current, epfd, events, maxevents, timeout));
 
@@ -1666,3 +1675,9 @@ module_init(eventpoll_init);
 module_exit(eventpoll_exit);
 
 MODULE_LICENSE("GPL");
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/fs/exec.c linux-2.6.16.5-cher1/fs/exec.c
--- linux-2.6.16.5/fs/exec.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/fs/exec.c	2006-04-13 11:55:22.000000000 +0400
@@ -127,6 +127,9 @@ asmlinkage long sys_uselib(const char __
 	struct nameidata nd;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = __user_path_lookup_open(library, LOOKUP_FOLLOW, &nd, FMODE_READ);
 	if (error)
 		goto out;
@@ -1526,3 +1529,9 @@ fail_unlock:
 fail:
 	return retval;
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+*/
diff -ruNp linux-2.6.16.5/fs/fcntl.c linux-2.6.16.5-cher1/fs/fcntl.c
--- linux-2.6.16.5/fs/fcntl.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/fs/fcntl.c	2006-04-13 11:55:22.000000000 +0400
@@ -142,6 +142,9 @@ asmlinkage long sys_dup2(unsigned int ol
 	struct files_struct * files = current->files;
 	struct fdtable *fdt;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	spin_lock(&files->file_lock);
 	if (!(file = fcheck(oldfd)))
 		goto out_unlock;
@@ -194,8 +197,12 @@ out_fput:
 asmlinkage long sys_dup(unsigned int fildes)
 {
 	int ret = -EBADF;
-	struct file * file = fget(fildes);
+	struct file * file;
+
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
 
+        file = fget(fildes);
 	if (file)
 		ret = dupfd(file, 0);
 	return ret;
@@ -357,6 +364,9 @@ asmlinkage long sys_fcntl(unsigned int f
 	struct file *filp;
 	long err = -EBADF;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	filp = fget(fd);
 	if (!filp)
 		goto out;
@@ -380,6 +390,9 @@ asmlinkage long sys_fcntl64(unsigned int
 	struct file * filp;
 	long err;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	err = -EBADF;
 	filp = fget(fd);
 	if (!filp)
@@ -623,3 +636,9 @@ static int __init fasync_init(void)
 }
 
 module_init(fasync_init)
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/fs/filesystems.c linux-2.6.16.5-cher1/fs/filesystems.c
--- linux-2.6.16.5/fs/filesystems.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/fs/filesystems.c	2006-04-13 11:55:22.000000000 +0400
@@ -182,6 +182,9 @@ asmlinkage long sys_sysfs(int option, un
 {
 	int retval = -EINVAL;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	switch (option) {
 		case 1:
 			retval = fs_index((const char __user *) arg1);
@@ -235,3 +238,9 @@ struct file_system_type *get_fs_type(con
 }
 
 EXPORT_SYMBOL(get_fs_type);
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/fs/inotify.c linux-2.6.16.5-cher1/fs/inotify.c
--- linux-2.6.16.5/fs/inotify.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/fs/inotify.c	2006-04-13 11:55:22.000000000 +0400
@@ -870,6 +870,9 @@ asmlinkage long sys_inotify_init(void)
 	struct file *filp;	
 	int fd, ret;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	fd = get_unused_fd();
 	if (fd < 0)
 		return fd;
@@ -937,6 +940,9 @@ asmlinkage long sys_inotify_add_watch(in
 	int mask_add = 0;
 	unsigned flags = 0;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	filp = fget_light(fd, &fput_needed);
 	if (unlikely(!filp))
 		return -EBADF;
@@ -1012,6 +1018,9 @@ asmlinkage long sys_inotify_rm_watch(int
 	struct inotify_device *dev;
 	int ret, fput_needed;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	filp = fget_light(fd, &fput_needed);
 	if (unlikely(!filp))
 		return -EBADF;
@@ -1078,3 +1087,9 @@ static int __init inotify_setup(void)
 }
 
 module_init(inotify_setup);
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/fs/ioctl.c linux-2.6.16.5-cher1/fs/ioctl.c
--- linux-2.6.16.5/fs/ioctl.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/fs/ioctl.c	2006-04-13 11:55:22.000000000 +0400
@@ -163,6 +163,9 @@ asmlinkage long sys_ioctl(unsigned int f
 	int error = -EBADF;
 	int fput_needed;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	filp = fget_light(fd, &fput_needed);
 	if (!filp)
 		goto out;
@@ -185,3 +188,9 @@ asmlinkage long sys_ioctl(unsigned int f
 #ifdef CONFIG_COMPAT
 EXPORT_SYMBOL(sys_ioctl);
 #endif
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/fs/ioprio.c linux-2.6.16.5-cher1/fs/ioprio.c
--- linux-2.6.16.5/fs/ioprio.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/fs/ioprio.c	2006-04-13 11:55:22.000000000 +0400
@@ -53,6 +53,9 @@ asmlinkage long sys_ioprio_set(int which
 	struct user_struct *user;
 	int ret;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	switch (class) {
 		case IOPRIO_CLASS_RT:
 			if (!capable(CAP_SYS_ADMIN))
@@ -125,6 +128,9 @@ asmlinkage long sys_ioprio_get(int which
 	struct user_struct *user;
 	int ret = -ESRCH;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	read_lock_irq(&tasklist_lock);
 	switch (which) {
 		case IOPRIO_WHO_PROCESS:
@@ -174,3 +180,8 @@ asmlinkage long sys_ioprio_get(int which
 	return ret;
 }
 
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/fs/locks.c linux-2.6.16.5-cher1/fs/locks.c
--- linux-2.6.16.5/fs/locks.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/fs/locks.c	2006-04-13 11:55:22.000000000 +0400
@@ -1499,6 +1499,9 @@ asmlinkage long sys_flock(unsigned int f
 	int can_sleep, unlock;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = -EBADF;
 	filp = fget(fd);
 	if (!filp)
@@ -2244,3 +2247,9 @@ static int __init filelock_init(void)
 }
 
 core_initcall(filelock_init);
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/fs/namei.c linux-2.6.16.5-cher1/fs/namei.c
--- linux-2.6.16.5/fs/namei.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/fs/namei.c	2006-04-13 11:55:22.000000000 +0400
@@ -1805,6 +1805,9 @@ asmlinkage long sys_mknodat(int dfd, con
 	struct dentry * dentry;
 	struct nameidata nd;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (S_ISDIR(mode))
 		return -EPERM;
 	tmp = getname(filename);
@@ -1879,6 +1882,9 @@ asmlinkage long sys_mkdirat(int dfd, con
 	int error = 0;
 	char * tmp;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	tmp = getname(pathname);
 	error = PTR_ERR(tmp);
 	if (!IS_ERR(tmp)) {
@@ -1978,6 +1984,9 @@ static long do_rmdir(int dfd, const char
 	struct dentry *dentry;
 	struct nameidata nd;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	name = getname(pathname);
 	if(IS_ERR(name))
 		return PTR_ERR(name);
@@ -2061,6 +2070,9 @@ static long do_unlinkat(int dfd, const c
 	struct nameidata nd;
 	struct inode *inode = NULL;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	name = getname(pathname);
 	if(IS_ERR(name))
 		return PTR_ERR(name);
@@ -2144,6 +2156,9 @@ asmlinkage long sys_symlinkat(const char
 	char * from;
 	char * to;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	from = getname(oldname);
 	if(IS_ERR(from))
 		return PTR_ERR(from);
@@ -2235,6 +2250,9 @@ asmlinkage long sys_linkat(int olddfd, c
 	if (flags != 0)
 		return -EINVAL;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	to = getname(newname);
 	if (IS_ERR(to))
 		return PTR_ERR(to);
@@ -2500,6 +2518,9 @@ asmlinkage long sys_renameat(int olddfd,
 	char * from;
 	char * to;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	from = getname(oldname);
 	if(IS_ERR(from))
 		return PTR_ERR(from);
@@ -2703,3 +2724,9 @@ EXPORT_SYMBOL(vfs_symlink);
 EXPORT_SYMBOL(vfs_unlink);
 EXPORT_SYMBOL(dentry_unhash);
 EXPORT_SYMBOL(generic_readlink);
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+*/
diff -ruNp linux-2.6.16.5/fs/namespace.c linux-2.6.16.5-cher1/fs/namespace.c
--- linux-2.6.16.5/fs/namespace.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/fs/namespace.c	2006-04-13 11:55:22.000000000 +0400
@@ -598,6 +598,9 @@ asmlinkage long sys_umount(char __user *
 	struct nameidata nd;
 	int retval;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	retval = __user_walk(name, LOOKUP_FOLLOW, &nd);
 	if (retval)
 		goto out;
@@ -1438,6 +1441,9 @@ asmlinkage long sys_mount(char __user * 
 	unsigned long dev_page;
 	char *dir_page;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	retval = copy_mount_options(type, &type_page);
 	if (retval < 0)
 		return retval;
@@ -1571,6 +1577,9 @@ asmlinkage long sys_pivot_root(const cha
 	struct nameidata new_nd, old_nd, parent_nd, root_parent, user_nd;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 
@@ -1763,3 +1772,9 @@ void __put_namespace(struct namespace *n
 	release_mounts(&umount_list);
 	kfree(namespace);
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/fs/nfsctl.c linux-2.6.16.5-cher1/fs/nfsctl.c
--- linux-2.6.16.5/fs/nfsctl.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/fs/nfsctl.c	2006-04-13 11:55:22.000000000 +0400
@@ -95,6 +95,9 @@ asmlinkage sys_nfsservctl(int cmd, struc
 	int version;
 	int err;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (copy_from_user(&version, &arg->ca_version, sizeof(int)))
 		return -EFAULT;
 
@@ -115,3 +118,9 @@ asmlinkage sys_nfsservctl(int cmd, struc
 	fput(file);
 	return err;
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/fs/open.c linux-2.6.16.5-cher1/fs/open.c
--- linux-2.6.16.5/fs/open.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/fs/open.c	2006-04-13 11:55:22.000000000 +0400
@@ -126,6 +126,9 @@ asmlinkage long sys_statfs(const char __
 	struct nameidata nd;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = user_path_walk(path, &nd);
 	if (!error) {
 		struct statfs tmp;
@@ -143,6 +146,9 @@ asmlinkage long sys_statfs64(const char 
 	struct nameidata nd;
 	long error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (sz != sizeof(*buf))
 		return -EINVAL;
 	error = user_path_walk(path, &nd);
@@ -163,6 +169,9 @@ asmlinkage long sys_fstatfs(unsigned int
 	struct statfs tmp;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -181,6 +190,9 @@ asmlinkage long sys_fstatfs64(unsigned i
 	struct statfs64 tmp;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (sz != sizeof(*buf))
 		return -EINVAL;
 
@@ -225,6 +237,9 @@ static long do_sys_truncate(const char _
 	struct inode * inode;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = -EINVAL;
 	if (length < 0)	/* sorry, but loff_t says... */
 		goto out;
@@ -292,6 +307,9 @@ static long do_sys_ftruncate(unsigned in
 	struct file * file;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = -EINVAL;
 	if (length < 0)
 		goto out;
@@ -366,6 +384,9 @@ asmlinkage long sys_utime(char __user * 
 	struct inode * inode;
 	struct iattr newattrs;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = user_path_walk(filename, &nd);
 	if (error)
 		goto out;
@@ -466,6 +487,9 @@ asmlinkage long sys_futimesat(int dfd, c
 {
 	struct timeval times[2];
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (utimes && copy_from_user(&times, utimes, sizeof(times)))
 		return -EFAULT;
 	return do_utimes(dfd, filename, utimes ? times : NULL);
@@ -489,6 +513,9 @@ asmlinkage long sys_faccessat(int dfd, c
 	kernel_cap_t old_cap;
 	int res;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (mode & ~S_IRWXO)	/* where's F_OK, X_OK, W_OK, R_OK? */
 		return -EINVAL;
 
@@ -539,6 +566,9 @@ asmlinkage long sys_chdir(const char __u
 	struct nameidata nd;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = __user_walk(filename, LOOKUP_FOLLOW|LOOKUP_DIRECTORY, &nd);
 	if (error)
 		goto out;
@@ -563,6 +593,9 @@ asmlinkage long sys_fchdir(unsigned int 
 	struct vfsmount *mnt;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -590,6 +623,9 @@ asmlinkage long sys_chroot(const char __
 	struct nameidata nd;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = __user_walk(filename, LOOKUP_FOLLOW | LOOKUP_DIRECTORY | LOOKUP_NOALT, &nd);
 	if (error)
 		goto out;
@@ -619,6 +655,9 @@ asmlinkage long sys_fchmod(unsigned int 
 	int err = -EBADF;
 	struct iattr newattrs;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	file = fget(fd);
 	if (!file)
 		goto out;
@@ -654,6 +693,9 @@ asmlinkage long sys_fchmodat(int dfd, co
 	int error;
 	struct iattr newattrs;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = __user_walk_fd(dfd, filename, LOOKUP_FOLLOW, &nd);
 	if (error)
 		goto out;
@@ -726,6 +768,9 @@ asmlinkage long sys_chown(const char __u
 	struct nameidata nd;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = user_path_walk(filename, &nd);
 	if (!error) {
 		error = chown_common(nd.dentry, user, group);
@@ -741,6 +786,9 @@ asmlinkage long sys_fchownat(int dfd, co
 	int error = -EINVAL;
 	int follow;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if ((flag & ~AT_SYMLINK_NOFOLLOW) != 0)
 		goto out;
 
@@ -759,6 +807,9 @@ asmlinkage long sys_lchown(const char __
 	struct nameidata nd;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = user_path_walk_link(filename, &nd);
 	if (!error) {
 		error = chown_common(nd.dentry, user, group);
@@ -773,6 +824,9 @@ asmlinkage long sys_fchown(unsigned int 
 	struct file * file;
 	int error = -EBADF;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	file = fget(fd);
 	if (file) {
 		error = chown_common(file->f_dentry, user, group);
@@ -1064,6 +1118,17 @@ long do_sys_open(int dfd, const char __u
 	char *tmp = getname(filename);
 	int fd = PTR_ERR(tmp);
 
+        if (!IS_ERR(tmp) && !capable(CAP_SYS_OPERATIONS)) {
+                char *s = tmp;
+                while (s[0] == '.' && s[1] == '/') s += 2;
+                for (; *s && *s != '/'; s++);
+                if (*s == '/') {
+                        putname(tmp);
+                        return -EPERM;
+                }
+                flags &= ~(O_CREAT | O_EXCL);
+        }
+
 	if (!IS_ERR(tmp)) {
 		fd = get_unused_fd();
 		if (fd >= 0) {
@@ -1093,6 +1158,9 @@ EXPORT_SYMBOL_GPL(sys_open);
 asmlinkage long sys_openat(int dfd, const char __user *filename, int flags,
 			   int mode)
 {
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (force_o_largefile())
 		flags |= O_LARGEFILE;
 
@@ -1174,6 +1242,9 @@ EXPORT_SYMBOL(sys_close);
  */
 asmlinkage long sys_vhangup(void)
 {
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (capable(CAP_SYS_TTY_CONFIG)) {
 		tty_vhangup(current->signal->tty);
 		return 0;
@@ -1207,3 +1278,9 @@ int nonseekable_open(struct inode *inode
 }
 
 EXPORT_SYMBOL(nonseekable_open);
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/fs/quota.c linux-2.6.16.5-cher1/fs/quota.c
--- linux-2.6.16.5/fs/quota.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/fs/quota.c	2006-04-13 11:55:22.000000000 +0400
@@ -351,6 +351,9 @@ asmlinkage long sys_quotactl(unsigned in
 	char *tmp;
 	int ret;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	cmds = cmd >> SUBCMDSHIFT;
 	type = cmd & SUBCMDMASK;
 
@@ -376,3 +379,9 @@ asmlinkage long sys_quotactl(unsigned in
 
 	return ret;
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/fs/readdir.c linux-2.6.16.5-cher1/fs/readdir.c
--- linux-2.6.16.5/fs/readdir.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/fs/readdir.c	2006-04-13 11:55:22.000000000 +0400
@@ -100,6 +100,9 @@ asmlinkage long old_readdir(unsigned int
 	struct file * file;
 	struct readdir_callback buf;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -180,6 +183,9 @@ asmlinkage long sys_getdents(unsigned in
 	struct getdents_callback buf;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = -EFAULT;
 	if (!access_ok(VERIFY_WRITE, dirent, count))
 		goto out;
@@ -266,6 +272,9 @@ asmlinkage long sys_getdents64(unsigned 
 	struct getdents_callback64 buf;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = -EFAULT;
 	if (!access_ok(VERIFY_WRITE, dirent, count))
 		goto out;
@@ -298,3 +307,9 @@ out_putf:
 out:
 	return error;
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/fs/read_write.c linux-2.6.16.5-cher1/fs/read_write.c
--- linux-2.6.16.5/fs/read_write.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/fs/read_write.c	2006-04-13 11:55:22.000000000 +0400
@@ -131,6 +131,9 @@ asmlinkage off_t sys_lseek(unsigned int 
 	struct file * file;
 	int fput_needed;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	retval = -EBADF;
 	file = fget_light(fd, &fput_needed);
 	if (!file)
@@ -158,6 +161,9 @@ asmlinkage long sys_llseek(unsigned int 
 	loff_t offset;
 	int fput_needed;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	retval = -EBADF;
 	file = fget_light(fd, &fput_needed);
 	if (!file)
@@ -381,6 +387,9 @@ asmlinkage ssize_t sys_pread64(unsigned 
 	ssize_t ret = -EBADF;
 	int fput_needed;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (pos < 0)
 		return -EINVAL;
 
@@ -402,6 +411,9 @@ asmlinkage ssize_t sys_pwrite64(unsigned
 	ssize_t ret = -EBADF;
 	int fput_needed;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (pos < 0)
 		return -EINVAL;
 
@@ -737,6 +749,9 @@ asmlinkage ssize_t sys_sendfile(int out_
 	off_t off;
 	ssize_t ret;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (offset) {
 		if (unlikely(get_user(off, offset)))
 			return -EFAULT;
@@ -755,6 +770,9 @@ asmlinkage ssize_t sys_sendfile64(int ou
 	loff_t pos;
 	ssize_t ret;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (offset) {
 		if (unlikely(copy_from_user(&pos, offset, sizeof(loff_t))))
 			return -EFAULT;
@@ -766,3 +784,9 @@ asmlinkage ssize_t sys_sendfile64(int ou
 
 	return do_sendfile(out_fd, in_fd, NULL, count, 0);
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
